#include "../main.h"

#include <zephyr/logging/log.h>
#include <zephyr/kernel.h>
#include <zephyr/types.h>
#include <zephyr/drivers/gpio.h>

#include <esb.h>

#include <zephyr/drivers/clock_control.h>
#include <zephyr/drivers/clock_control/nrf_clock_control.h>
#include <zephyr/drivers/gpio.h>
#include <zephyr/irq.h>
#include <zephyr/logging/log.h>
#include <nrf.h>
#include <esb.h>
#include <zephyr/device.h>
#include <zephyr/devicetree.h>
#include <zephyr/kernel.h>
#include <zephyr/types.h>
#include <zephyr/kernel/thread_stack.h>

#include "profile4.h"

LOG_MODULE_REGISTER(profile4, LOG_LEVEL_INF);

#define STACKSIZE 1024
#define THREAD_PRIORITY 7

void protocol4_0(gate_t mygate, int athlete, timing_t timing)
{
	int gate;
	mygate.chan = chan1;
	mygate.prod = rapidgate;

	k_sleep(K_MSEC(timing.del0));

	//GATE 0
	gate = 0;
	mygate.entry = gateStatusCommon(mygate, gate, broken);
	k_sleep(K_MSEC(timing.dur0));
	mygate.exit = gateStatusCommon(mygate, gate, !broken);

	printGateCommon(mygate, gate, athlete);

	k_sleep(K_MSEC(timing.del1));

	// GATE 1
	gate++;
	mygate.entry = gateStatusCommon(mygate, gate, broken);
	k_sleep(K_MSEC(timing.dur1));
	mygate.exit = gateStatusCommon(mygate, gate, !broken);

	printGateCommon(mygate, gate, athlete);

	k_sleep(K_MSEC(timing.del2));

	// GATE 2
	gate++;
	mygate.entry = gateStatusCommon(mygate, gate, broken);
	k_sleep(K_MSEC(timing.dur2));
	mygate.exit = gateStatusCommon(mygate, gate, !broken);

	printGateCommon(mygate, gate, athlete);

	k_sleep(K_MSEC(timing.del3));

	// GATE 3
	gate++;
	mygate.entry = gateStatusCommon(mygate, gate, broken);
	k_sleep(K_MSEC(timing.dur3));
	mygate.exit = gateStatusCommon(mygate, gate, !broken);

	printGateCommon(mygate, gate, athlete);
}



int MyAthlete = 0;

K_MUTEX_DEFINE(test_mutex);

int shared_code_athlete(){
	k_mutex_lock(&test_mutex, K_FOREVER);
	MyAthlete++;
	k_mutex_unlock(&test_mutex);

	return MyAthlete;
}

void thread0(void)
{	
int athlete = 0;
	LOG_INF("thread0");
	while(1){
        // int athlete = shared_code_athlete();

 athlete++;
        if(athlete >= 50){
            k_yield();
            return;
        }
	}
}

extern void my_entry_point0(void *, void *, void *){
	LOG_INF("my_entry_point0");
	// thread0();
	LOG_INF("my_entry_point0 exit");
}

static K_THREAD_STACK_DEFINE(dyn_thread_stack0, STACKSIZE);

int protocol4_init()
{
    int T = 0;
	struct k_thread thread0_id;
	struct k_thread my_thread_data;

	k_tid_t my_tid = k_thread_create(&my_thread_data, dyn_thread_stack0,
                                 K_THREAD_STACK_SIZEOF(dyn_thread_stack0),
                                 my_entry_point0,
                                 NULL, NULL, NULL,
                                 THREAD_PRIORITY, 0, K_NO_WAIT);
	
	LOG_INF("my_tid is done");

	return 0;
}