#include <zephyr/kernel.h>
#include <zephyr/drivers/gpio.h>
#include <zephyr/logging/log.h>

LOG_MODULE_REGISTER(main, LOG_LEVEL_INF);

#define MY_STACK_SIZE 500
#define THREAD_PRIORITY 5

K_THREAD_STACK_DEFINE(dyn_thread_stack_0, MY_STACK_SIZE);
K_THREAD_STACK_DEFINE(dyn_thread_stack_1, MY_STACK_SIZE);

extern void my_entry_point_0(void *, void *, void *){
	LOG_INF("my_entry_point_0");
};

extern void my_entry_point_1(void *, void *, void *){
	LOG_INF("my_entry_point_1");
}

void create_thread_from_function()
{
	struct k_thread my_thread_data_1;

	k_tid_t my_tid = k_thread_create(&my_thread_data_1, dyn_thread_stack_1,
						K_THREAD_STACK_SIZEOF(dyn_thread_stack_1),
						my_entry_point_1,
						NULL, NULL, NULL,
						THREAD_PRIORITY, 0, K_FOREVER);

	//  k_thread_start(my_tid); //this line causes error
	
	 /*
	 	ASSERTION FAIL @ WEST_TOPDIR/zephyr/arch/arm/core/aarch32/mpu/arm_core_mpu.c:287
		E: r0/a1:  0x00000004  r1/a2:  0x0000011f  r2/a3:  0x00000001
		E: r3/a4:  0x0000000e r12/ip:  0x200014b0 r14/lr:  0x00001d3f
		E:  xpsr:  0x6100000e
		E: Faulting instruction address (r15/pc): 0x00009cc6
		E: >>> ZEPHYR FATAL ERROR 4: Kernel panic on CPU 0
		E: Fault during interrupt handling

		E: Current thread: 0x200013f0 (unknown)
		E: Resetting system*** Booting nRF Connect SDK v2.5.1 ***
	*/
}

int main(void)
{
	printk("main() Simulator\n");

	struct k_thread my_thread_data_0;

	k_tid_t my_tid = k_thread_create(&my_thread_data_0, dyn_thread_stack_0,
						K_THREAD_STACK_SIZEOF(dyn_thread_stack_0),
						my_entry_point_0,
						NULL, NULL, NULL,
						THREAD_PRIORITY, 0, K_FOREVER);

	k_thread_start(my_tid); //this line causes error

	create_thread_from_function();

	k_msleep(10000);

	return 0;
}