#ifndef _MAIN_H_
#define _MAIN_H_

#include <zephyr/types.h>

#include <zephyr/drivers/clock_control.h>
#include <zephyr/drivers/clock_control/nrf_clock_control.h>
#include <zephyr/drivers/gpio.h>
#include <zephyr/irq.h>
#include <zephyr/logging/log.h>
#include <nrf.h>
#include <esb.h>
#include <zephyr/device.h>
#include <zephyr/devicetree.h>
#include <zephyr/kernel.h>
#include <zephyr/types.h>

#define maxGateNumber 4
extern const struct gpio_dt_spec sw[maxGateNumber];
extern const struct gpio_dt_spec leds[maxGateNumber];

enum channels {chan1=1, chan2=2, chan3=3, chan4=4};
enum products {dummy, rapidgate, rapidstep, rapidrelease};

typedef struct{
	uint8_t chan;
	uint8_t prod;
	char uuid[13];
	uint32_t entry;
	uint32_t exit;
}gate_t;

extern gate_t mygate_0;
extern gate_t mygate_1;
extern gate_t mygate_2;
extern gate_t mygate_3;
extern gate_t mygate_wearable;

typedef struct timesync{
	uint32_t child;
	uint32_t parent;
	uint32_t delta;
}timesync_t;

extern timesync_t mytimesync;

extern const int broken;

uint32_t gateStatusCommon(gate_t mygate, int gate, int status);
void printGateCommon(gate_t mygate, int gate, int athlete);

typedef struct{
	int dur0;
	int dur1;
	int dur2;
	int dur3;
	int del0;
	int del1;
	int del2;
	int del3;
}timing_t;

extern timing_t timing;

#endif